/**
 *
 */
package de.intevation.gnv.transition;

import org.apache.log4j.Logger;
import org.w3c.dom.Node;

import de.intevation.gnv.artifacts.GNVArtifactBase;

/**
 * @author Tim Englich <tim.englich@intevation.de>
 * 
 */
public class TransitionFactory {

    /**
     * the logger, used to log exceptions and additonaly information
     */
    private static Logger log = Logger.getLogger(GNVArtifactBase.class);

    private static TransitionFactory instance = null;

    /**
     * Constructor
     */
    public TransitionFactory() {
        super();
    }

    public static TransitionFactory getInstance() {
        if (instance == null) {
            instance = new TransitionFactory();
        }
        return instance;
    }

    public Transition createTransition(Node configuration) {
        log.debug("TransitionFactory.createTransition");
        Transition transition = null;
        try {
            String classname = ((org.w3c.dom.Element)configuration).getAttribute("transition");
            transition = (Transition) (Class.forName(classname).newInstance());
            transition.setup(configuration);
        } catch (InstantiationException e) {
            log.error(e, e);
        } catch (IllegalAccessException e) {
            log.error(e, e);
        } catch (ClassNotFoundException e) {
            log.error(e, e);
        }
        return transition;
    }

}
